<template>
    <div>
        <breadcrumb-component title="Gerenciar produtos" :pages="breadPages"/>

        <panel-component title="Listar produtos">

            <div class="form-search">
                <div class="form-group col-md-6">
                    <router-link class="btn btn-primary" :to="{name: 'products.create'}">
                        <i class="fa fa-plus-circle"></i> Cadastrar Produto
                    </router-link>
                </div>

                <div class="form-group col-md-6 form-inline text-right">
                    <div class="input-group">
                        <input type="text" placeholder="Pesquisar por nome" class="form-control"
                               v-model="formSearch.nome">
                        <span class="input-group-btn">
                            <button type="button" class="btn btn-primary" @click.prevent="loadProducts(1)">
                                 <i class="fa fa-search"></i>
                            </button>
                        </span>
                    </div>
                    <button type="button" class="btn btn-white" @click.prevent="isFormSearch = !isFormSearch">
                        <i class="fa fa-search-plus"></i> Busca avançada
                    </button>
                </div>
            </div>

            <div class="col-md-12 label-form" v-if="isFormSearch">
                <div class="form-group col-md-2">
                    <label>Categoria</label>
                    <select class="form-control" v-model="formSearch.categoria" v-select2>
                        <option value="">--Selecione--</option>
                        <option v-for="category in categories" :value="category.id">{{category.name}}</option>
                    </select>
                </div>

                <div class="form-group col-md-4">
                    <label>Nome</label>
                    <input type="text" class="form-control" v-model="formSearch.nome"/>
                </div>

                <div class="form-group col-md-6">
                    <label>Fornecedor</label>
                    <select class="form-control" v-model="formSearch.fornecedor" v-select2>
                        <option value="">--Selecione--</option>
                        <option v-for="provider in providers" :value="provider.id">{{provider.name}}</option>
                    </select>
                </div>

                <div class="form-group col-md-3">
                    <label>Codigo de barras</label>
                    <input type="text" class="form-control" v-model="formSearch.codigo_barras"/>
                </div>

                <div class="form-group col-md-3">
                    <label>Codigo interno</label>
                    <input type="text" class="form-control" v-model="formSearch.codigo_interno"/>
                </div>


                <div class="form-group col-md-12">
                    <button class="btn btn-primary" @click.prevent="loadProducts(1)">
                        <i class="fa fa-search"></i> Buscar
                    </button>
                    <button class="btn btn-white" @click.prevent="isFormSearch = false">
                        <i class="fa fa-remove"></i> Fechar
                    </button>
                </div>
            </div>

            <div class="table-responsive col-md-12">
                <table class="table table-striped table-hover table-bordered">
                    <thead>
                    <tr>
                        <th>Código interno</th>
                        <th>Nome</th>
                        <th>
                            Total estoque
                            <a v-tooltip="info">
                                <span class="text-info info"><i class="fa fa-info-circle"></i></span>
                            </a>
                        </th>
                        <th>Cadastrado em</th>
                        <th class="text-center" style="width: 130px">Ação</th>
                    </tr>
                    </thead>
                    <tbody>
                    <tr v-for="(product, index) in this.products.data" :key="index">
                        <td>{{product.codigo_interno }}</td>
                        <td>{{product.nome }}</td>
                        <td>{{ calcEstoque(product.product_grids) }}</td>
                        <td>{{product.created_at | dateFormat}}</td>
                        <td class="text-center">
                            <router-link
                                    :to="{name: 'products.detail', params: {id: product.id}}"
                                    class="btn btn-xs btn-white btn-dim">
                                <i class="fa fa-eye"></i>
                            </router-link>
                            <router-link
                                    :to="{name: 'products.edit', params: {id: product.id}}"
                                    class="btn btn-xs btn-info">
                                <i class="fa fa-pencil"></i>
                            </router-link>
                            <button class="btn btn-xs btn-danger" @click.prevent="confirmDestroy(product)">
                                <i class="fa fa-trash"></i>
                            </button>
                        </td>
                    </tr>
                    </tbody>
                </table>
                <p>
                    Mostrando: {{products.data.length}} de um total de: {{products.total}} registros.</p>
                <pagination
                        :data="products"
                        :limit="1"
                        @pagination-change-page="loadProducts">
                    <span slot="prev-nav">Anterior</span>
                    <span slot="next-nav">Próximo</span>
                </pagination>
            </div>

        </panel-component>

    </div>
</template>

<script>
    export default {
        data() {
            return {
                formSearch: {
                    nome: '',
                    codigo_interno: '',
                    codigo_barras: '',
                    categoria: '',
                    fornecedor: '',
                },
                info: 'Caso o produto tenha variação sera mostrado a soma do estoque de todas as variações do produto,' +
                ' apenas nessa tabela. Para ver detalhes de cada variação, clique em Detalhes',
                isFormSearch: false,
                providers: {},
                categories: {},
                breadPages: [
                    {link: 'dashboard', name: 'Dashboard', active: false},
                    {link: 'products', name: 'Gerenciar Produtos', active: false},
                    {link: 'products', name: 'Listar', active: true},
                ]
            }
        },

        created() {
            this.loadProducts(1)
            this.loadProviders()
            this.loadCategories()
        },

        computed: {
            products() {
                return this.$store.state.products.items
            },
            params() {
                return {
                    nome: this.formSearch.nome,
                    codigo_interno: this.formSearch.codigo_interno,
                    codigo_barras: this.formSearch.codigo_barras,
                    categoria: this.formSearch.categoria,
                    fornecedor: this.formSearch.fornecedor,
                }
            }
        },

        methods: {
            calcEstoque(grids) {
                let total = 0
                grids.forEach((grid) => {
                    total += grid.estoque_atual
                })
                return total
            },

            loadProducts(page) {
                this.$store.dispatch('loadProducts', {...this.params, page})
            },
            confirmDestroy(product) {
                this.$snotify.confirm(`Deseja realmente apagar o produto: ${product.nome} ?`, 'Deletar ?', {
                    timeout: 5000,
                    showProgressBar: true,
                    closeOnClick: false,
                    pauseOnHover: true,
                    buttons: [
                        {
                            text: 'Sim', action: (toast) => {
                            this.$snotify.remove(toast.id)
                            this.destroyProduct(product.id)
                        }
                        },
                        {
                            text: 'Não', action: (toast) => {
                            this.$snotify.remove(toast.id)
                        }
                        },
                    ]
                })
            },

            destroyProduct(id) {
                this.$store.dispatch('destroyProduct', id)
                    .then(() => {
                        this.loadProducts(1)
                        this.$snotify.success('produto apagado com sucesso!', 'Sucesso')
                    })
                    .catch(() => {
                        this.$snotify.error('Não foi possível apagar o produto!', 'Error')
                    })
            },

            loadProviders() {
                this.$store.dispatch('loadProviders', {select: 'select'})
                    .then((response) => {
                        this.providers = response
                    })
            },

            loadCategories() {
                this.$store.dispatch('loadProductCategories', {select: 'select'})
                    .then((response) => {
                        this.categories = response
                    })
            },
        }
    }
</script>

<style>
    .info {
        font-size: 15px;
    }
</style>

